<template>
  <div class="q-pa-sm">
    <q-banner class="bg-warning text-white q-my-sm" rounded>
      Sort doesnt work, because PokéAPI
    </q-banner>
    <q-table
      :data="pokemons"
      :columns="columns"
      row-key="name"
      :pagination.sync="pagination"
      :loading="loading"
      @request="onRequest"
    >
      <template v-slot:body-cell-actions="props">
        <q-td class="text-right">
          <q-btn
            dense
            flat
            text-color="primary"
            label="detail"
            :to="props.value"
          />
        </q-td>
      </template>
    </q-table>
    <ErrorBanner v-if="error" :error="error" />
  </div>
</template>

<script>
import capitalize from 'lodash/capitalize'
import ErrorBanner from 'src/components/ErrorBanner'

export default {
  name: 'PokemonsList',
  components: {
    ErrorBanner,
  },
  props: {
    pokemons: {
      type: Array,
      required: true,
    },
    loading: {
      type: Boolean,
      required: true,
    },
    count: {
      type: Number,
      required: true,
    },
    error: {
      default: null,
    },
  },
  data() {
    return {
      filter: '',
      neco: '',
      columns: [
        {
          name: 'name',
          required: true,
          label: 'Name',
          align: 'left',
          field: row => capitalize(row.name),
          format: val => `${val}`,
          sortable: true,
        },
        {
          name: 'actions',
          label: 'Actions',
          align: 'right',
          field: row => `/pokemons/${row.name}`,
        },
      ],
    }
  },
  computed: {
    pagination: {
      get() {
        return this.$store.getters['pokemons/pokemonsPagination']
      },
      set(value) {
        this.$store.commit('pokemons/SET_POKEMONS_PAGINATION', value)
      },
    },
  },
  methods: {
    onRequest(props) {
      this.pagination = props.pagination
      this.$store.dispatch('pokemons/getPokemonsList')
    },
  },
}
</script>
